#line 1 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Driver.c"
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/led_driver.h"
#line 25 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/led_driver.h"
void Display_Init(void);
void Display_Write(unsigned _data);
void Display_Setup(void);
char DisplayAll(char *Msg);
void SetDigit(char Digit, char _data, char DecPt);
void SetDecodeReg(char Mask);
void LowerIntensity(void);
void RaiseIntensity(void);

void Shutdown(void);
void Normal(void);
void BlinkSlow(void);
void BlinkFast(void);
void BlinkOff(void);

void Test(char Mask);
void Increment(void);
void DispTest(char OnOff);
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/usb_driver.h"
#line 11 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/buffers.h"
#line 15 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/buffers.h"
char* GetBuffer(void);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 11 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Driver.c"
sbit CS_LED at GPIOD_ODR.B2;



char Intensity = 0x07;
char Configuration = 0x01;
#line 23 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Driver.c"
void Display_Init(void) {


 GPIO_Config(&GPIOD_BASE, _GPIO_PINMASK_2, _GPIO_CFG_DIGITAL_OUTPUT);
 CS_LED = 1;

 SPI3_Init_Advanced(_SPI_FPCLK_DIV64, _SPI_MASTER | _SPI_16_BIT | _SPI_CLK_IDLE_LOW |
 _SPI_FIRST_CLK_EDGE_TRANSITION | _SPI_MSB_FIRST | _SPI_SS_DISABLE |
 _SPI_SSM_ENABLE | _SPI_SSI_1, &_GPIO_MODULE_SPI3_PC10_11_12);

 Display_Setup();
}
#line 41 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Driver.c"
void Display_Write(unsigned _data) {

 CS_LED = 0;
 SPI3_Write(_data);
 CS_LED = 1;
}
#line 52 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Driver.c"
void Display_Setup(void) {
 unsigned CmdDat;

  ((char *)&CmdDat)[1]  =  0x04 ;
  ((char *)&CmdDat)[0]  = Configuration;
 Display_Write(CmdDat);

  ((char *)&CmdDat)[1]  =  0x03 ;
  ((char *)&CmdDat)[0]  = 0x07;
 Display_Write(CmdDat);

  ((char *)&CmdDat)[1]  =  0x01 ;
  ((char *)&CmdDat)[0]  = 0xFF;
 Display_Write(CmdDat);

  ((char *)&CmdDat)[1]  =  0x02 ;
  ((char *)&CmdDat)[0]  = Intensity;
 Display_Write(CmdDat);
}
#line 76 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Driver.c"
char DisplayAll(char *Msg) {
 char i;
 unsigned CmdDat;
 char *BufNum;

 if ((strlen(Msg) > 0) && (strlen(Msg) < 9)) {
 for (i=0;i<strlen(Msg);i++) {
  ((char *)&CmdDat)[1]  =  0x60  + i;
  ((char *)&CmdDat)[0]  = Msg[i];
 Display_Write(CmdDat);


 BufNum = GetBuffer();
 sprintf(BufNum,"0x%04X",CmdDat);
 USB_PutQueue(BufNum);
 }
 return 0;
 } else {

 BufNum = GetBuffer();
 sprintf(BufNum,"Length: %d",strlen(Msg));
 USB_PutQueue(BufNum);

 return 1;
 }
}
#line 108 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Driver.c"
void SetDigit(char Digit, char _data, char DecPt) {
 unsigned CmdDat;
 char *BufNum;

 if ((Digit >= 0) && (Digit <=8)) {
 switch (Digit) {
 case 0:
  ((char *)&CmdDat)[1]  =  0x60  + 0;
  ((char *)&CmdDat)[0]  = _data;
 if (DecPt)  ((char *)&CmdDat)[0]  |= 0x80;
 break;
 case 1:
  ((char *)&CmdDat)[1]  =  0x60  + 1;
  ((char *)&CmdDat)[0]  = _data;
 if (DecPt)  ((char *)&CmdDat)[0]  |= 0x80;
 break;
 case 2:
  ((char *)&CmdDat)[1]  =  0x60  + 2;
  ((char *)&CmdDat)[0]  = _data;
 if (DecPt)  ((char *)&CmdDat)[0]  |= 0x80;
 break;
 case 3:
  ((char *)&CmdDat)[1]  =  0x60  + 3;
  ((char *)&CmdDat)[0]  = _data;
 if (DecPt)  ((char *)&CmdDat)[0]  |= 0x80;
 break;
 case 4:
  ((char *)&CmdDat)[1]  =  0x60  + 4;
  ((char *)&CmdDat)[0]  = _data;
 if (DecPt)  ((char *)&CmdDat)[0]  |= 0x80;
 break;
 case 5:
  ((char *)&CmdDat)[1]  =  0x60  + 5;
  ((char *)&CmdDat)[0]  = _data;
 if (DecPt)  ((char *)&CmdDat)[0]  |= 0x80;
 break;
 case 6:
  ((char *)&CmdDat)[1]  =  0x60  + 6;
  ((char *)&CmdDat)[0]  = _data;
 if (DecPt)  ((char *)&CmdDat)[0]  |= 0x80;
 break;
 case 7:
  ((char *)&CmdDat)[1]  =  0x60  + 7;
  ((char *)&CmdDat)[0]  = _data;
 if (DecPt)  ((char *)&CmdDat)[0]  |= 0x80;
 break;
 }
 Display_Write(CmdDat);
 } else {

 BufNum = GetBuffer();
 sprintf(BufNum,"Digit error: %d",Digit);
 USB_PutQueue(BufNum);
 }
}
#line 171 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Driver.c"
void SetDecodeReg(char Mask) {
 unsigned CmdDat;

  ((char *)&CmdDat)[1]  =  0x01 ;
  ((char *)&CmdDat)[0]  = Mask;
 Display_Write(CmdDat);
}
#line 182 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Driver.c"
void LowerIntensity(void) {
 unsigned CmdDat;
 char *BufNum;

 if (Intensity > 0) {
 Intensity -= 1;
  ((char *)&CmdDat)[1]  =  0x02 ;
  ((char *)&CmdDat)[0]  = Intensity;
 Display_Write(CmdDat);
 }

 BufNum = GetBuffer();
 sprintf(BufNum,"Intensity: %d",Intensity);
 USB_PutQueue(BufNum);
}
#line 201 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Driver.c"
void RaiseIntensity(void) {
 unsigned CmdDat;
 char *BufNum;

 if (Intensity < 0x0F) {
 Intensity += 1;
  ((char *)&CmdDat)[1]  =  0x02 ;
  ((char *)&CmdDat)[0]  = Intensity;
 Display_Write(CmdDat);
 }

 BufNum = GetBuffer();
 sprintf(BufNum,"Intensity: %d",Intensity);
 USB_PutQueue(BufNum);
}
#line 226 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Driver.c"
void Shutdown(void) {
 unsigned CmdDat;
 char *BufNum;

  ((char *)&CmdDat)[1]  =  0x04 ;
 Configuration &= 0xFE;
  ((char *)&CmdDat)[0]  = Configuration;
 Display_Write(CmdDat);


 BufNum = GetBuffer();
 sprintf(BufNum,"Configuration: %02X",Configuration);
 USB_PutQueue(BufNum);
}

void Normal(void) {
 unsigned CmdDat;
 char *BufNum;

  ((char *)&CmdDat)[1]  =  0x04 ;
 Configuration |= 0x01;
  ((char *)&CmdDat)[0]  = Configuration;
 Display_Write(CmdDat);


 BufNum = GetBuffer();
 sprintf(BufNum,"Configuration: %02X",Configuration);
 USB_PutQueue(BufNum);
}

void BlinkSlow(void) {
 unsigned CmdDat;
 char *BufNum;

  ((char *)&CmdDat)[1]  =  0x04 ;
 Configuration &= 0xFB;
 Configuration |= 0x08;
  ((char *)&CmdDat)[0]  = Configuration;
 Display_Write(CmdDat);


 BufNum = GetBuffer();
 sprintf(BufNum,"Configuration: %02X",Configuration);
 USB_PutQueue(BufNum);
}

void BlinkFast(void) {
 unsigned CmdDat;
 char *BufNum;

  ((char *)&CmdDat)[1]  =  0x04 ;
 Configuration |= 0x0C;
  ((char *)&CmdDat)[0]  = Configuration;
 Display_Write(CmdDat);


 BufNum = GetBuffer();
 sprintf(BufNum,"Configuration: %02X",Configuration);
 USB_PutQueue(BufNum);
}

void BlinkOff(void) {
 unsigned CmdDat;
 char *BufNum;

  ((char *)&CmdDat)[1]  =  0x04 ;

 Configuration &= 0xFD;
  ((char *)&CmdDat)[0]  = Configuration;
 Display_Write(CmdDat);


 BufNum = GetBuffer();
 sprintf(BufNum,"Configuration: %02X",Configuration);
 USB_PutQueue(BufNum);
}

void Test(char Mask) {
 unsigned CmdDat;
 char *BufNum;

  ((char *)&CmdDat)[1]  =  0x04 ;
 Configuration = Mask;
  ((char *)&CmdDat)[0]  = Configuration;
 Display_Write(CmdDat);


 BufNum = GetBuffer();
 sprintf(BufNum,"Configuration: %02X",Configuration);
 USB_PutQueue(BufNum);
}

void Increment(void) {
 unsigned CmdDat;
 char *BufNum;

  ((char *)&CmdDat)[1]  =  0x04 ;
 Configuration += 1;
  ((char *)&CmdDat)[0]  = Configuration;
 Display_Write(CmdDat);


 BufNum = GetBuffer();
 sprintf(BufNum,"Configuration: %02X",Configuration);
 USB_PutQueue(BufNum);
}

void DispTest(char OnOff) {
 unsigned CmdDat;

  ((char *)&CmdDat)[1]  =  0x07 ;
  ((char *)&CmdDat)[0]  = OnOff;
 Display_Write(CmdDat);
}
