/**************************************************************************************************
  LED_Driver.h

**************************************************************************************************/
#ifndef LED_DRIVER_H
#define LED_DRIVER_H


// Defines
#define NO_OP 0x00
#define DECODE_MODE 0x01
#define INTENSITY 0x02
#define SCAN_LIMIT 0x03
#define CONFIGURATION 0x04
#define DISPLAY_TEST 0x07

#define DIG0P0 0x20
#define DIG0P1 0x40
#define DIG0P0P1 0x60




// Function Prototypes
void Display_Init(void);
void Display_Write(unsigned _data);
void Display_Setup(void);
char DisplayAll(char *Msg);
void SetDigit(char Digit, char _data, char DecPt);
void SetDecodeReg(char Mask);
void LowerIntensity(void);
void RaiseIntensity(void);

void Shutdown(void);
void Normal(void);
void BlinkSlow(void);
void BlinkFast(void);
void BlinkOff(void);

void Test(char Mask);
void Increment(void);
void DispTest(char OnOff);




#endif