/**************************************************************************************************
 * Project name:
     LED_Main.c
 * Generated by:
     MikroC
 * Date of creation
     2015/07/18
 * Time of creation
     03:08:00 PM
 * Test configuration:
     MCU:             STM32F407VG
     Dev.Board:       Mikromedia for STM32 M4
     Oscillator:      16 MHz internal
     PLL:             120 MHz
     SW:              mikroC PRO for ARM

 * Shield slot 1 is populated with a custom board that uses the MAX6951 8-digit LED display driver.


**************************************************************************************************/
// Include Files
#include "USB_Driver.h"
#include "Timers.h"
#include "LED_Driver.h"
#include "TFT_Driver.h"


// Variables
unsigned short int MainTimer;          // Timer handle for this module




// Program entry point
void main() {

     USB_Init();                       // Initialize USB

     Timer_Init();                     // Initialize timers
     MainTimer = get_timer();          // Get a timer handle
     set_timer(MainTimer,2000);        // Set timer

     // Delay while USB enumerates
     while (check_timer(MainTimer) != 0) {
     }
     USB_PutQueue(" ");
     USB_PutQueue("LED display program started");

     Display_Init();
     Start_TP();
     EnableInterrupts();               // Global enable interrupts

     // Main loop
     while (1) {

         USB_CheckIn();                // Check for incoming USB messages
         USB_CheckOut();               // Check for outgoing USB messages

         TimerCheck();                 // Check timer pool
     }
}

/**************************************************************************************************
  EOF
**************************************************************************************************/