/**************************************************************************************************
  TFT_Driver.c
**************************************************************************************************/
#include "resources.h"


// TFT module connections
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RST at GPIOE_ODR.B8;
sbit TFT_RS at GPIOE_ODR.B12;
sbit TFT_CS at GPIOE_ODR.B15;
sbit TFT_RD at GPIOE_ODR.B10;
sbit TFT_WR at GPIOE_ODR.B11;
sbit TFT_BLED at GPIOE_ODR.B9;
// End TFT module connections


// Touch Panel module connections
sbit DriveX_Left at GPIOB_ODR.B1;
sbit DriveX_Right at GPIOB_ODR.B8;
sbit DriveY_Up at GPIOB_ODR.B9;
sbit DriveY_Down at GPIOB_ODR.B0;
// End Touch Panel module connections


/**************************************************************************************************
  Init MCU function
**************************************************************************************************/
void Init_MCU() {
     // TFT BLED config
     GPIO_Config(&GPIOE_BASE, _GPIO_PINMASK_9, _GPIO_CFG_DIGITAL_OUTPUT);
     TFT_BLED = 1;
     TFT_Set_Default_Mode();
     TFT_Init_ILI9341_8bit(320, 240);

     // CS Serial Flash config
     //GPIO_Config(&GPIOD_BASE, _GPIO_PINMASK_7, _GPIO_CFG_DIGITAL_OUTPUT);
}

/**************************************************************************************************
  Draw Screen function
**************************************************************************************************/
void DrawScr(void) {
     TFT_Fill_Screen(CL_WHITE);
     TFT_Set_Pen(CL_Black, 1);
     TFT_Line(20, 220, 300, 220);
     TFT_LIne(20,  46, 300,  46);
     TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_RED, FO_HORIZONTAL);
     TFT_Write_Text("LCD     DISPLAY", 90, 14);
     TFT_Set_Font(&Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL);
     TFT_Write_Text("Mikromedia for STM32 M4", 20, 223);
     TFT_Set_Font(&Verdana12x13_Regular, CL_RED, FO_HORIZONTAL);
     TFT_Write_Text("Val Gretchev", 220, 223);
     TFT_Set_Font(&TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
     TFT_Set_Font(&Tahoma130x160_Regular, CL_GREEN, FO_HORIZONTAL);
     TFT_Write_Text("0000", 20, 30);
}

/**************************************************************************************************
  Initialize Touch Panel function
**************************************************************************************************/
void Init_TouchPanel(void) {
     //TP_TFT_Set_Default_Mode();

}

/**************************************************************************************************
  Initialize TFT and Touch Panel
**************************************************************************************************/
void Start_TP(void) {
     Init_MCU();
     DrawScr();
     //Init_TouchPanel();

}