_SystemTimerInterrupt:
;Timers.c,23 :: 		void SystemTimerInterrupt() iv IVT_INT_SysTick ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,24 :: 		if (COUNTFLAG_bit) {              // Interrupts every millisecond
MOVW	R0, #lo_addr(COUNTFLAG_bit+0)
MOVT	R0, #hi_addr(COUNTFLAG_bit+0)
LDR	R1, [R0, #0]
UBFX	R0, R1, BitPos(COUNTFLAG_bit+0), #1
CMP	R0, #0
IT	EQ
BEQ	L_SystemTimerInterrupt0
;Timers.c,25 :: 		irqhandler_timer();           // Service timer pool
BL	_irqhandler_timer+0
;Timers.c,27 :: 		Msec += 1;                    // Increment millisecond counter
MOVW	R2, #lo_addr(_Msec+0)
MOVT	R2, #hi_addr(_Msec+0)
LDRH	R0, [R2, #0]
ADDS	R1, R0, #1
UXTH	R1, R1
STRH	R1, [R2, #0]
;Timers.c,28 :: 		if (Msec > 999) {             // When counter goes to 1000
MOVW	R0, #999
CMP	R1, R0
IT	LS
BLS	L_SystemTimerInterrupt1
;Timers.c,29 :: 		Msec = 0;                 // Set it to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_Msec+0)
MOVT	R0, #hi_addr(_Msec+0)
STRH	R1, [R0, #0]
;Timers.c,30 :: 		TimerFlag = 1;            // Set 1 second flag
MOVS	R1, #1
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;Timers.c,31 :: 		}
L_SystemTimerInterrupt1:
;Timers.c,32 :: 		}
L_SystemTimerInterrupt0:
;Timers.c,33 :: 		}
L_end_SystemTimerInterrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _SystemTimerInterrupt
_Timer_Init:
;Timers.c,38 :: 		void Timer_Init() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,39 :: 		init_timerpool();                 // Make all timers free
BL	_init_timerpool+0
;Timers.c,42 :: 		NVIC_SYSTICKRVR = 15000;          // Set reload value register for 120 MHz
MOVW	R1, #15000
MOVW	R0, #lo_addr(NVIC_SYSTICKRVR+0)
MOVT	R0, #hi_addr(NVIC_SYSTICKRVR+0)
STR	R1, [R0, #0]
;Timers.c,43 :: 		NVIC_SYSTICKCVR = 0;              // Reset timer counter
MOVS	R1, #0
MOVW	R0, #lo_addr(NVIC_SYSTICKCVR+0)
MOVT	R0, #hi_addr(NVIC_SYSTICKCVR+0)
STR	R1, [R0, #0]
;Timers.c,44 :: 		ENABLE_SYSTICKCSR_bit = 1;        // Enable timer
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(ENABLE_SYSTICKCSR_bit+0)
MOVT	R1, #hi_addr(ENABLE_SYSTICKCSR_bit+0)
LDR	R0, [R1, #0]
BFI	R0, R2, BitPos(ENABLE_SYSTICKCSR_bit+0), #1
STR	R0, [R1, #0]
;Timers.c,45 :: 		TICKINT_bit = 1;                  // Enable timer interrupt
MOVW	R1, #lo_addr(TICKINT_bit+0)
MOVT	R1, #hi_addr(TICKINT_bit+0)
LDR	R0, [R1, #0]
BFI	R0, R2, BitPos(TICKINT_bit+0), #1
STR	R0, [R1, #0]
;Timers.c,46 :: 		}
L_end_Timer_Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer_Init
_TimerCheck:
;Timers.c,51 :: 		void TimerCheck() {
;Timers.c,52 :: 		if (TimerFlag == 1) {
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
LDRSH	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_TimerCheck2
;Timers.c,53 :: 		TimerFlag = 0;                // Reset 1 second flag
MOVS	R1, #0
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;Timers.c,56 :: 		}
L_TimerCheck2:
;Timers.c,57 :: 		}
L_end_TimerCheck:
BX	LR
; end of _TimerCheck
_init_timerpool:
;Timers.c,89 :: 		void init_timerpool(void) {
;Timers.c,92 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_init_timerpool3:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_init_timerpool4
;Timers.c,93 :: 		TimerPool[i].TimerField = 0;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STR	R0, [R1, #0]
;Timers.c,94 :: 		TimerPool[i].Free = TRUE;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #1
STRB	R0, [R1, #0]
;Timers.c,92 :: 		for (i=0; i < NUMTIMERS; i++) {
ADDS	R2, R2, #1
UXTB	R2, R2
;Timers.c,95 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_init_timerpool3
L_init_timerpool4:
;Timers.c,96 :: 		}
L_end_init_timerpool:
BX	LR
; end of _init_timerpool
_get_timer:
;Timers.c,104 :: 		unsigned short int get_timer(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,107 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_get_timer6:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_get_timer7
;Timers.c,108 :: 		if (TimerPool[i].Free == TRUE) {  // If a free timer is found
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_get_timer9
;Timers.c,109 :: 		TimerPool[i].Free = FALSE;    // Mark it reserved
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #0
STRB	R0, [R1, #0]
;Timers.c,110 :: 		return i;                     // Return timer handle
UXTB	R0, R2
; i end address is: 8 (R2)
IT	AL
BAL	L_end_get_timer
;Timers.c,111 :: 		}
L_get_timer9:
;Timers.c,107 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
ADDS	R2, R2, #1
UXTB	R2, R2
;Timers.c,112 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_get_timer6
L_get_timer7:
;Timers.c,115 :: 		USB_PutQueue("TIMERS: No Timers, Resetting..\r\n");
MOVW	R0, #lo_addr(?lstr1_Timers+0)
MOVT	R0, #hi_addr(?lstr1_Timers+0)
BL	_USB_PutQueue+0
;Timers.c,116 :: 		SystemReset();
BL	_SystemReset+0
;Timers.c,117 :: 		return (0);
MOVS	R0, #0
;Timers.c,118 :: 		}
L_end_get_timer:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _get_timer
_free_timer:
;Timers.c,126 :: 		void free_timer(unsigned short int nbr) {
; nbr start address is: 0 (R0)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
;Timers.c,127 :: 		if (nbr > (NUMTIMERS-1))          // Make a simple check
CMP	R0, #9
IT	LS
BLS	L_free_timer10
; nbr end address is: 0 (R0)
;Timers.c,128 :: 		return;
IT	AL
BAL	L_end_free_timer
L_free_timer10:
;Timers.c,130 :: 		TimerPool[nbr].Free = TRUE;
; nbr start address is: 0 (R0)
LSLS	R2, R0, #3
; nbr end address is: 0 (R0)
MOVW	R1, #lo_addr(_TimerPool+0)
MOVT	R1, #hi_addr(_TimerPool+0)
ADDS	R1, R1, R2
ADDS	R2, R1, #4
MOVS	R1, #1
STRB	R1, [R2, #0]
;Timers.c,131 :: 		}
L_end_free_timer:
BX	LR
; end of _free_timer
_set_timer:
;Timers.c,140 :: 		void set_timer(unsigned short int nbr, unsigned long int tout) {
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
; tout end address is: 4 (R1)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
; tout start address is: 4 (R1)
;Timers.c,141 :: 		if (nbr > (NUMTIMERS-1))          // Make a simple check
CMP	R0, #9
IT	LS
BLS	L_set_timer11
; nbr end address is: 0 (R0)
; tout end address is: 4 (R1)
;Timers.c,142 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer11:
;Timers.c,144 :: 		if (TimerPool[nbr].Free == TRUE)
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
LSLS	R3, R0, #3
MOVW	R2, #lo_addr(_TimerPool+0)
MOVT	R2, #hi_addr(_TimerPool+0)
ADDS	R2, R2, R3
ADDS	R2, R2, #4
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L_set_timer12
; nbr end address is: 0 (R0)
; tout end address is: 4 (R1)
;Timers.c,145 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer12:
;Timers.c,147 :: 		TimerPool[nbr].TimerField = tout;
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
LSLS	R3, R0, #3
; nbr end address is: 0 (R0)
MOVW	R2, #lo_addr(_TimerPool+0)
MOVT	R2, #hi_addr(_TimerPool+0)
ADDS	R2, R2, R3
STR	R1, [R2, #0]
; tout end address is: 4 (R1)
;Timers.c,148 :: 		}
L_end_set_timer:
BX	LR
; end of _set_timer
_check_timer:
;Timers.c,156 :: 		unsigned long int check_timer(unsigned short int nbr) {
; nbr start address is: 0 (R0)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
;Timers.c,157 :: 		return TimerPool[nbr].TimerField;
LSLS	R2, R0, #3
; nbr end address is: 0 (R0)
MOVW	R1, #lo_addr(_TimerPool+0)
MOVT	R1, #hi_addr(_TimerPool+0)
ADDS	R1, R1, R2
LDR	R1, [R1, #0]
MOV	R0, R1
;Timers.c,158 :: 		}
L_end_check_timer:
BX	LR
; end of _check_timer
_irqhandler_timer:
;Timers.c,166 :: 		void irqhandler_timer(void) {
;Timers.c,169 :: 		for (i=0; i<NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_irqhandler_timer13:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_irqhandler_timer14
;Timers.c,170 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__irqhandler_timer21
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L__irqhandler_timer20
L__irqhandler_timer19:
;Timers.c,171 :: 		TimerPool[i].TimerField--;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R1, R0, R1
LDR	R0, [R1, #0]
SUBS	R0, R0, #1
STR	R0, [R1, #0]
;Timers.c,170 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
L__irqhandler_timer21:
L__irqhandler_timer20:
;Timers.c,169 :: 		for (i=0; i<NUMTIMERS; i++) {
ADDS	R2, R2, #1
UXTB	R2, R2
;Timers.c,172 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_irqhandler_timer13
L_irqhandler_timer14:
;Timers.c,173 :: 		}
L_end_irqhandler_timer:
BX	LR
; end of _irqhandler_timer
